Sub Main()
     print "Starting Family Photos"

     m.imageSizeX = 1280
     m.imageSizeY = 720
     m.index = 0

     port = CreateObject("roMessagePort")
     m.screen = CreateObject("roScreen", true)
     m.screen.SetAlphaEnable(true)
     m.screen.Clear(&h000000FF) 
     m.screen.SetMessagePort(port)

     m.arrayImages = [ 
          "pkg:/images/Slide01.jpg", "pkg:/images/Slide02.jpg", "pkg:/images/Slide03.jpg"
           ]
     m.slideCount = m.arrayImages.Count()

     m.currentBitmap = CreateObject("roBitmap", m.arrayImages[m.index])
     m.currentBitmap.SetAlphaEnable(true)

     m.scaleX = m.screen.GetWidth() / m.imageSizeX
     m.scaleY = m.screen.GetHeight() / m.imageSizeY
     m.screen.DrawScaledObject(0, 0, m.scaleX, m.scaleY, m.currentBitmap)

     ChangeSlide()

     While(True)

          msg = wait(0, port) 
          If type(msg) = "roUniversalControlEvent" Then
               button = msg.GetInt()

               If ((button = 5) Or (button = 6)) and m.index < m.slideCount - 1 Then
                    print "Show Next Slide"
                    m.index = m.index + 1
                    ChangeSlide()
               Else If (button = 4) And (m.index > 0)  Then
                    print "Show Previous Slide"
                    m.index = m.index - 1
                    ChangeSlide()
               End If
          End If

     End While

End Sub


Function ChangeSlide()

     If m.index < 0 Then
          m.nextBitmap = CreateObject("roBitmap", "pkg:/images/background.jpg")
     Else If m.index >= m.slideCount Then
          m.nextBitmap = CreateObject("roBitmap", "pkg:/images/background.jpg")
     Else
          m.nextBitmap = CreateObject("roBitmap", m.arrayImages[m.index])
     End If

     m.nextBitmap.SetAlphaEnable(true)

     For i = 0 to 255 Step 5
          hexcolor = &hFFFFFFFF - i
          hexcolor2  = &hFFFFFF00 + i

          m.screen.DrawScaledObject(0, 0, m.scaleX, m.scaleY, m.currentBitmap, hexcolor) 'fadeout
          m.screen.DrawScaledObject(0, 0, m.scaleX, m.scaleY, m.nextBitmap, hexcolor2) 'fadein

          m.screen.SwapBuffers()
     End For

     m.currentBitmap = 0 'release the current bitmap
     m.currentBitmap = m.nextBitmap 'assign the new next bitmap
     m.nextBitmap = 0 'release the next bitmap

End Function

